#include <stdio.h>
#include "debug.h"
#include "util.h"
#include "equation.h"

int main(int argc, char **argv) {
        double lb;
        double rtt, t0;
        int i;
        int inverse = 0;

        for (i = 1; i < argc; ++i) {
                if (argv[i][0] == '-') {
                        switch (argv[i][1]) {
                        case 'i' : inverse = 1; break;
                        default : fprintf(stderr, "unknown option: %s\n", argv[i]); exit(1); break;
                        }
                }
        }

        while (1) {
                if (!inverse)
                        printf("lossrate: ");
                else
                        printf("bitrate: ");
                scanf("%lf", &lb);
                printf("rtt (ms): ");
                scanf("%lf", &rtt);
                printf("t_0 (ms): ");
                scanf("%lf", &t0);
                if (!inverse)
                        printf("-> bitrate = %f byte/s\n", bitrate_eq(lb, rtt, t0));
                else
                        printf("-> lossrate = %f\n", lossfraction_eq(lb, rtt, t0));
        }
        return 0;
}
