#include <math.h>
#include <float.h>
#include <stdio.h>

#include "util.h"
#include "equation.h"
#include "config.h"


double br_1(double l, double rtt, double t0) {
        double rtt_s = (double) rtt / MILLISEC;
        double t0_s  = (double) t0 / MILLISEC;
        double tmp   = min(3 * sqrt(3*EQN_B*l/8), 1.0);
        return PKT_SIZE / (rtt_s * sqrt(2*EQN_B*l/3) + t0_s * tmp * l * (1 + 32*l*l));
}


double lf_1(double bitrate, double rtt, double t0) {
        /* assume loss fraction is between DBL_EPSILON and 1.0 */
        double l1 = 1.0, l2, l3 = DBL_EPSILON;
        double b1 = bitrate_eq(l1, rtt, t0), b2, b3 = bitrate_eq(l3, rtt, t0);
        int count = 100;

        if (b1 > bitrate)
                return 1.0;
        if (b3 < bitrate)
                return 0.0;

        while (--count) {
                l2 = l1 + (l3 - l1) / 2;
                b2 = bitrate_eq(l2, rtt, t0);
                if (b2 > bitrate + 0.5) {
                        l3 = l2;
                        b3 = b2;
                } else if (b2 < bitrate - 0.5) {
                        l1 = l2;
                        b1 = b2;
                } else {
                        break;
                }
        }
        return l2;
}
