#!/bin/sh

tcpnum=$2
udpnum=$3

simnr=0
hname=`hostname`
syncport=27520
portsuffix=58
portsuffix1=`expr $portsuffix + 1`
duration=$5

echo "$1 x ($tcpnum x tcp, $udpnum x udp)"

dumpcmd="tcpdump -v -n 'host $hname and (port"
nr=0
while [ $nr -lt $udpnum ] ; do
    port=`expr $nr + 100`
    if [ $nr -gt 0 ] ; then
	dumpcmd="$dumpcmd or"
    fi
    dumpcmd="$dumpcmd ${port}${portsuffix} or ${port}${portsuffix1}"
    nr=`expr $nr + 1`
done
nr=0
while [ $nr -lt $tcpnum ] ; do
    port=`expr $nr + 200`
    if [ $nr -gt 0 -o $udpnum -ne 0 ] ; then
	dumpcmd="$dumpcmd or"
    fi
    dumpcmd="$dumpcmd ${port}${portsuffix} or ${port}${portsuffix1}"
    nr=`expr $nr + 1`
done
dumpcmd="$dumpcmd)' > net.log &"

echo waiting for sender...
sleep 5 # start sender in meantime !

while [ $simnr -lt $1 ] ; do
    simnr=`expr $simnr + 1`
    echo run $simnr

    tcpsender $4 $syncport > /dev/null
    if [ $? -eq 1 ] ; then
	exit 1
    fi
    echo synchronized
    echo $dumpcmd
    eval $dumpcmd
    tcpdumppid=$!
    sleep 1

    nr=0    
    while [ $nr -lt $tcpnum ] ; do
	port=`expr $nr + 200`
	nr=`expr $nr + 1`
	tcpreceiver ${port}${portsuffix} -t $duration -l -n $nr &
    done

    duration=`expr $duration + 10`

    nr=0
    while [ $nr -lt $udpnum ] ; do
	port=`expr $nr + 100`
	nr=`expr $nr + 1`
	receiver $4 ${port}${portsuffix} -t $duration -n $nr -w 8 &
    done

    sleep $duration

    sleep 20
    stopall.sh
    kill $tcpdumppid
    movelog.sh $simnr
done
