#!/bin/sh
tcpnum=$2
udpnum=$3

simnr=0
hname=`hostname`
syncport=27520
portsuffix=58
portsuffix1=`expr $portsuffix + 1`
logdir=$HOME/tfm/log
echo "$1 x ($tcpnum x tcp, $udpnum x udp) $dm"
delay=0

dumpcmd="tcpdump -v -n 'host $hname and (port"
nr=0
while [ $nr -lt $udpnum ] ; do
    port=`expr $nr + 100`
    if [ $nr -gt 0 ] ; then
	dumpcmd="$dumpcmd or"
    fi
    dumpcmd="$dumpcmd ${port}${portsuffix} or ${port}${portsuffix1}"
    nr=`expr $nr + 1`
done
nr=0
while [ $nr -lt $tcpnum ] ; do
    port=`expr $nr + 200`
    if [ $nr -gt 0 -o $udpnum -ne 0 ] ; then
	dumpcmd="$dumpcmd or"
    fi
    dumpcmd="$dumpcmd ${port}${portsuffix} or ${port}${portsuffix1}"
    nr=`expr $nr + 1`
done
dumpcmd="$dumpcmd)' > nets.log &"

while [ $simnr -lt $1 ] ; do
    dt=$5
    simnr=`expr $simnr + 1`
    echo run $simnr

    tcpreceiver $syncport -s > /dev/null
    if [ $? -eq 1 ] ; then
	exit 1
    fi
    echo synchronized
    sleep 5

    echo $dumpcmd
    eval $dumpcmd
    tcpdumppid=$!

    nr=0
    while [ $nr -lt $udpnum ] ; do
	port=`expr $nr + 100`
	nr=`expr $nr + 1`
	sender $4 ${port}${portsuffix} -t $dt -i 100 -p 1.0 -e 4 -k 4 &
	dt=`expr $dt - $delay`
	sleep $delay
    done

    nr=0
    while [ $nr -lt $tcpnum ] ; do
	port=`expr $nr + 200`
	nr=`expr $nr + 1`
	tcpsender $4 ${port}${portsuffix} &
	dt=`expr $dt - $delay`
	sleep $delay
    done

    sleep $dt
    stopall.sh

    kill $tcpdumppid
    movelog.sh $simnr
done
